diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/error-rate-model.h ns-3.34/src/wifi/model/error-rate-model.h
--- ns-3.33/src/wifi/model/error-rate-model.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/error-rate-model.h	2021-07-14 10:31:07.000000000 -0700
@@ -22,12 +22,10 @@
 #define ERROR_RATE_MODEL_H
 
 #include "ns3/object.h"
+#include "wifi-mode.h"
 
 namespace ns3 {
 
-class WifiTxVector;
-class WifiMode;
-
 /**
  * \ingroup wifi
  * \brief the interface for Wifi's error models
@@ -48,7 +46,13 @@
    *
    * \return the SNR which corresponds to the requested BER
    */
-  double CalculateSnr (WifiTxVector txVector, double ber) const;
+  double CalculateSnr (const WifiTxVector& txVector, double ber) const;
+
+  /**
+   * \return true if the model is for AWGN channels,
+   *         false otherwise
+   */
+  virtual bool IsAwgn (void) const;
 
   /**
    * This method returns the probability that the given 'chunk' of the
@@ -72,10 +76,25 @@
    * \param txVector TXVECTOR of the overall transmission
    * \param snr the SNR of the chunk
    * \param nbits the number of bits in this chunk
+   * \param numRxAntennas the number of active RX antennas (1 if not provided)
+   * \param field the PPDU field to which the chunk belongs to (assumes this is for the payload part if not provided)
+   * \param staId the station ID for MU
    *
    * \return probability of successfully receiving the chunk
    */
-  double GetChunkSuccessRate (WifiMode mode, WifiTxVector txVector, double snr, uint64_t nbits) const;
+  double GetChunkSuccessRate (WifiMode mode, const WifiTxVector& txVector, double snr, uint64_t nbits,
+                              uint8_t numRxAntennas = 1, WifiPpduField field = WIFI_PPDU_FIELD_DATA,
+                              uint16_t staId = SU_STA_ID) const;
+
+  /**
+   * Assign a fixed random variable stream number to the random variables
+   * used by this model. Return the number of streams (possibly zero) that
+   * have been assigned.
+   *
+   * \param stream first stream index to use
+   * \return the number of stream indices assigned by this model
+   */
+  virtual int64_t AssignStreams (int64_t stream);
 
 
 private:
@@ -86,10 +105,14 @@
    * \param txVector TXVECTOR of the overall transmission
    * \param snr the SNR of the chunk
    * \param nbits the number of bits in this chunk
+   * \param numRxAntennas the number of active RX antennas
+   * \param field the PPDU field to which the chunk belongs to
+   * \param staId the station ID for MU
    *
    * \return probability of successfully receiving the chunk
    */
-  virtual double DoGetChunkSuccessRate (WifiMode mode, WifiTxVector txVector, double snr, uint64_t nbits) const = 0;
+  virtual double DoGetChunkSuccessRate (WifiMode mode, const WifiTxVector& txVector, double snr, uint64_t nbits,
+                                        uint8_t numRxAntennas, WifiPpduField field, uint16_t staId) const = 0;
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/extended-capabilities.h ns-3.34/src/wifi/model/extended-capabilities.h
--- ns-3.33/src/wifi/model/extended-capabilities.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/extended-capabilities.h	2021-07-14 10:31:07.000000000 -0700
@@ -37,17 +37,17 @@
   ExtendedCapabilities ();
 
   // Implementations of pure virtual methods of WifiInformationElement
-  WifiInformationElementId ElementId () const;
-  uint8_t GetInformationFieldSize () const;
-  void SerializeInformationField (Buffer::Iterator start) const;
+  WifiInformationElementId ElementId () const override;
+  uint8_t GetInformationFieldSize () const override;
+  void SerializeInformationField (Buffer::Iterator start) const override;
   uint8_t DeserializeInformationField (Buffer::Iterator start,
-                                       uint8_t length);
+                                       uint8_t length) override;
   /* This information element is a bit special in that it is only
      included if the STA is a HT STA. To support this we
      override the Serialize and GetSerializedSize methods of
      WifiInformationElement. */
-  Buffer::Iterator Serialize (Buffer::Iterator start) const;
-  uint16_t GetSerializedSize () const;
+  Buffer::Iterator Serialize (Buffer::Iterator start) const override;
+  uint16_t GetSerializedSize () const override;
 
   /**
    * Set the HT Supported flag.
